from collections import defaultdict

def read_input():
    n, m, k = map(int, input().split())
    roads = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        roads[a].append(b)
        roads[b].append(a)
    guards = {}
    for _ in range(k):
        p, h = map(int, input().split())
        guards[p] = h
    return n, m, k, roads, guards

def bfs(start, roads, guards):
    visited = set()
    queue = [(start, 0)]
    while queue:
        node, distance = queue.pop(0)
        if node in visited:
            continue
        visited.add(node)
        if node in guards and distance <= guards[node]:
            return True
        for neighbor in roads[node]:
            if neighbor not in visited:
                queue.append((neighbor, distance + 1))
    return False

def find_protected_warehouses(n, roads, guards):
    protected = []
    for warehouse in range(1, n + 1):
        if bfs(warehouse, roads, guards):
            protected.append(warehouse)
    return protected

if __name__ == "__main__":
    n, m, k, roads, guards = read_input()
    protected_warehouses = find_protected_warehouses(n, roads, guards)
    print(len(protected_warehouses))
    if protected_warehouses:
        print(*sorted(protected_warehouses))