import sys
import collections

def bfs(graph, start):
    queue = collections.deque([start])
    visited = set([start])
    distances = {start: 0}

    while queue:
        current = queue.popleft()
        for neighbor in graph[current]:
            if neighbor not in visited:
                visited.add(neighbor)
                queue.append(neighbor)
                distances[neighbor] = distances[current] + 1

    return distances

def main():
    n, m, k = map(int, sys.stdin.readline().split())
    graph = [[] for _ in range(n + 1)]
    for _ in range(m):
        a, b = map(int, sys.stdin.readline().split())
        graph[a].append(b)
        graph[b].append(a)
    guards = {}
    for _ in range(k):
        p, h = map(int, sys.stdin.readline().split())
        guards[p] = h

    protected = set()
    for guard_position, guard_range in guards.items():
        distances = bfs(graph, guard_position)
        for warehouse, distance in distances.items():
            if distance <= guard_range:
                protected.add(warehouse)

    print(len(protected))
    if protected:
        print(*sorted(protected))

if __name__ == "__main__":
    main()